#!C:/tcl/bin/wish41
wm title . "Ampere's Law"


# Wire - takes care of placing the wire shape on the right position and on right distance
#from the point charge taking in consideration the chosen type of wire shape. $where specifies
#on what widget we want to place the wire shape
 
proc Wire { where } {
     global envir loop_x loop_y center_x center_y
     set a [expr ($loop_y-$center_y)/($loop_x-$center_x)] 
     set a [expr atan($a)]
     set dx [expr 30*$envir(dist)*cos($a)]
     set dy [expr 30*$envir(dist)*sin($a)]
     if { $center_x > $loop_x} {
          set dx [expr $dx*(-1)]
          set dy [expr $dy*(-1)]
        }
     set loop_x [expr $center_x+$dx]
     set loop_y [expr $center_y+$dy]
     set size [expr 30*$envir(size)]
     set what $envir(looptype)
     if {$what == "circle"} {
        $where create oval [expr $loop_x-$size] [expr $loop_y-$size] [expr $loop_x+$size] \
          [expr $loop_y+$size] -width 4 -outline green  -tags item 
      }
     if {$what == "triangle"} {
        $where create line $loop_x [expr $loop_y-$size*sqrt(3)/3] [expr $loop_x -$size/2] [expr $loop_y+$size*sqrt(3)/6]\
          [expr $loop_x+$size/2] [expr $loop_y+$size*sqrt(3)/6] $loop_x [expr $loop_y-$size*sqrt(3)/3] -width 4 -fill green -tags item
     }
     if {$what == "square"} {
       $where create rect [expr $loop_x-$size/2] [expr $loop_y-$size] [expr $loop_x+$size] \
          [expr $loop_y+$size] -width 4 -outline green -tags item
     }
     pack $where
    
   $where bind item <1> "itemStartDrag $where %x %y "
   $where bind item <B1-Motion> "itemDrag $where %x %y "
   $where bind item <Double-1>  "ChangeLoop"
   $where bind item  <Enter> {.menu.messag.mesg configure -text "Click and drag to move, double-click to change the wire shape"}
  # $where bind item <Leave> {.menu.messag.mesg configure -text "Welcome to Ampere's Law"}
   
  #takes the current x and y coordinates before the moving starts 
  proc itemStartDrag { c x y} {
    global lastX lastY
    set lastX [$c canvasx $x]
    set lastY [$c canvasy $y]
  }

  # moving the wire shape and redrawing it on the screen with updating the distance on
  # the message bar
 
  proc itemDrag {c x y  } {
    global lastX lastY center_x center_y loop_x loop_y envir
    set x [$c canvasx $x]
    set y [$c canvasy $y]
    $c move item [expr $x-$lastX] [expr $y-$lastY]
    $c delete tangenti
    set dx [expr $x-$lastX]
    set dy [expr $y-$lastY]
    set loop_x [expr $loop_x+$dx]
    set loop_y [expr $loop_y+$dy]
    set distance [expr sqrt ((($loop_x-$center_x)*($loop_x-$center_x)+($loop_y-$center_y)*($loop_y-$center_y))/900)]
    set lastX $x
    set lastY $y
    set envir(dist) $distance
    set distance [format "%5.2f" $distance]
    .menu.help.mesg configure -text "DIstance from the point source is $distance"
   # .menu.messag.mesg configure -text "Distance is $distance cm and  $lastX  $lastY  $loop_x  $loop_y"
    }
} 


# ChangeIntensity-changing the intensity of the magnetic field
proc ChangeIntensity { } {
      global envir value
      set ok 0
      set f [toplevel .changeintensity  -borderwidth 40]
      wm  title $f ChangeIntensity
      frame $f.field -width 300 -height 60
      label $f.field.label -text "Field Strength:" -padx 0
      entry $f.field.entry -width 4 -textvariable value
      button $f.but -text OK -command {set ok 1}
      pack $f.field.label $f.field.entry -side left -expand true -fill x
      pack $f.field $f.but 
      bind $f.field.entry <Return> {SetValue .menu.main.bar.canvas1 lbox}
      focus $f
      grab $f
      tkwait variable ok
      grab release $f
      destroy $f
      if {$ok} { 
          SetValue .menu.main.bar.canvas1 lbox
      } else {
          return {}
      }
}  

#Animate - drawing the circles of the magnetic field        
proc Animate { where { bool 0}} {
   global envir loop_x loop_y center_x center_y
   set distance 6
   set MAX $envir(intense)
   set center_x 245
   set center_y 160
  # loop parameters, centered at this point
  set loop_x  [expr $center_x+30*$envir(dist)]
  set loop_y  $center_y 
   # code to create a point charge

   $where create oval [expr $center_x-5] [expr $center_y-5] [expr $center_x+5]\
               [expr $center_y+5] -fill red -tags charge

  # code to create up to MAXimum number of field gradient circles
  # next few lines replace circles with krugovi if problem

  $where delete circles
  for {set i 1} {$i<[expr $MAX*3]} {incr i 3} \
  {
   $where create oval [expr $center_x-$i*$distance] [expr $center_y-$i*$distance]\
               [expr $center_x+$i*$distance] [expr $center_y+$i*$distance] \
                -width 2 -outline blue -tags circles
   $where lower circles
   }
   if { $bool == 0} {
      Wire $where 
    }
  $where bind charge <Enter> {.menu.messag.mesg configure -text "Double click on the point charge to change the field strength"}
  $where bind charge <Double-1> "ChangeIntensity"
}

#Scale2 - creating the slide bar for changing the magnetic field on the main screen
# w- is the widget, min - is the minimum, max - the maximum distance in pixels from
# the corner of the window, so width computes how much is the actual width of the slide bar

proc Scale2 { w min max {width {}} } {
    global scale2
    if {$width == {}} {
       set width [expr $max -$min]
    }
    
    set scale2($w,scale) [expr ($max-$min)/$width.0]
    set scale2($w,min) $min
    set scale2($w,max) $max
    set scale2($w,Min) $min
    set scale2($w,Max) $max
    set scale2($w,L) 10
    set scale2($w,R) [expr $width + 10]

    $w create rect 0 0 110 0 -tag slider
    $w create rect 35 -4 45 10 -fill blue -tag {left lbox} 
    $w create poly 0 40 110 40 110 15 0 40 -fill black

    set scale [expr ($width+10) /110.0]
    $w scale slider 0 0 $scale 1.0
    $w move all 10 10

    $w bind left <Button-1> {BoxBegin %W %x lbox}
    $w bind left <B1-Motion> {BoxDrag %W %x lbox}
    $w bind left <Enter> { .menu.messag.mesg config -text "Drag the slider to change the field strength"}
}

# BoxBegin - what we are trying to drag
   proc BoxBegin { w x what } {
    global scale2
    set scale2($w,$what) $x
   }

#BoxDrag - draging the box inside the slide bar
   proc BoxDrag {w x what } {
    global scale2 value envir
    set x1 $scale2($w,$what)
    set scale2($w,$what) $x 
    set dx [expr $x-$x1]
    set lx [lindex [$w coords lbox] 0]
    if {$what == "lbox"} {
        if {$lx+$dx > $scale2($w,R)} {
          set dx [expr  $scale2($w,R)-$lx]
          set scale2($w,$what) $scale2($w,R)
        } elseif {$lx + $dx < $scale2($w,L)} {
             set dx [expr $scale2($w,L) - $lx]
             set scale2($w,$what) $scale2($w,L)
         }
    $w move left $dx 0
    set lx [lindex [$w coords lbox] 0]
    set scale2($w,min) [expr int($scale2($w,Min) + \
          ($lx - $scale2($w,L)) * $scale2($w,scale))]
  }
  set value [expr ($lx / 10.0) -1.0] 
  set envir(intense) $value
  Animate .menu.main.glaven.can 1
 }

#Scale2Value - returns list of the min and max values of the slide bar 
proc Scale2Value {w} {
     global scale2
     return [list $scale2($w,min) $scale2($w,max)]
 }

#Dialog - forms a dialog box with title diag and error message err 
proc Dialog { diag err } {
    
    after idle {.dialog1.msg configure -wraplength 4i}
    set i [tk_dialog .dialog1 "$diag" "$err" \
           info 0 OK] 
    }

#SetValue - setting the value of the field strength with checking the range, if wrong calling
#the Dialog procedure, otherwise updates the value on the slide bar and animates the circles
# of the magnetic field on the main screen

proc SetValue { c what } {
  global value envir
  if { ($value < 0) || ($value >10)} {
     Dialog "Incorrect Input" "You should enter number in the range of 0-10"
  } else {
  if [catch { expr $value} result] {
       set errmessage "You should enter number in the range of 0-10"
       set diagtitle "Incorrect Input"
       Dialog  $diagtitle $errmessage 
  } else {
  set lx [lindex [$c coords $what] 0]
  set dx [expr $result * 11 - $lx]
  $c move left $dx 0
  set envir(intense) $value
  Animate .menu.main.glaven.can 1
  }
 }
}

#Choose - according to the chosen type of wire shape or force diagram raises or sunks the
#relief of the rest of the buttons on the screen

proc Choose { Looptype  which num} {
     global envir 
     set butlist {}
     if { $which == ".changeLoop.fpic"} {
        set envir(force) $Looptype
        set envir(num1) $num
        foreach but { first second } {
             if { $but != $num } {
             lappend butlist $but
             }
           }	
     } else {
           set envir(looptype) $Looptype
           set envir(num) $num
           foreach but { first second third } {
             if { $but != $num } {
             lappend butlist $but
           }
         }
     }
     foreach x  $butlist {
     $which.$x configure -relief raised
     }
     $which.$num configure -relief sunken   
}   


#ChangeLoop - procedure for changing the type of wire shape
proc ChangeLoop  {} {
  global envir
  set f [toplevel .changeLoop -borderwidth 10] 
  frame $f.shapes -height 60
  frame $f.param -height 60
  frame $f.fpic -height 60
  frame $f.buttons -height 40
  label $f.wires -text "Wire Shapes"
  label $f.force -text "Flux Intensity Diagrams"

  button $f.buttons.ok -text "OK" -underline 0 -command { set envir(loopok) 1}
  button $f.buttons.cancel -text "Cancel" -underline 0 -command {set envir(loopok) 0}
  button $f.buttons.default -text "Defaults" -underline 0 -command { set envir(dist) 4; set envir(size) 2; set envir(looptype) "circle"; set envir(force) "three"}
  button $f.buttons.help -text "Help" -underline 0 -command ChLoopHelp
    set d [pwd]
  set im1 [image create bitmap -file $d/circle.xbm] 
  set im2 [image create bitmap -file $d/triangle.xbm] 
  set im3 [image create bitmap -file $d/square.xbm] 
  set im4 [image create bitmap -file $d/three.xbm]
  set im5 [image create bitmap -file $d/one.xbm]

  button $f.shapes.first -image $im1 -command "Choose circle $f.shapes first "
  button $f.shapes.second -image $im2 -command "Choose triangle $f.shapes second"
  button $f.shapes.third -image $im3 -command "Choose square $f.shapes third"
  button $f.fpic.first -image $im4 -command "Choose three $f.fpic first"
  button $f.fpic.second -image $im5 -command "Choose one $f.fpic second"

  label $f.param.side -text "Radius/Side (cm):" -padx 5 -pady 5
  label $f.param.dis -text "Distance(cm):" -padx 5 -pady 5
  entry $f.param.disval -width 5 -relief sunken -textvariable envir(dist) 
  entry $f.param.sideval -width 5 -relief sunken -textvariable envir(size)
  bind $f.param.disval <Return> "$f.param.disval get "
  bind $f.param.sideval <Return> "$f.param.sideval get "
  
  pack $f.param.side $f.param.sideval $f.param.dis $f.param.disval -side left
  pack $f.fpic.first $f.fpic.second -side left
  pack $f.shapes.first $f.shapes.second $f.shapes.third -side left
  pack $f.buttons.ok $f.buttons.cancel $f.buttons.default $f.buttons.help -side left
  pack $f.wires $f.shapes $f.param $f.force $f.fpic $f.buttons -side top
  Choose $envir(looptype) $f.shapes $envir(num)
  Choose $envir(force) $f.fpic $envir(num1)
  focus $f
  grab $f
  tkwait variable envir(loopok)
  grab release $f
  destroy $f
  if {$envir(loopok) } { 
     .menu.main.glaven.can delete item
     Wire .menu.main.glaven.can
     .menu.main.bar.canvas2 itemconfig forcing -bitmap @$envir(forim)/$envir(force).xbm 
     .menu.help.mesg config -text "Distance is $envir(dist) cm"
  } else {
       return {}
    }
}

#Amperes -procedure for giving the screen for Amperes's equation
   
proc Amperes { } {
 global mx theList Equt

    proc Quiteqn { } {
       destroy .e
    }
    set mx(aud) 1
    set file [pwd]
    set file $file/equation.txt
    if { [winfo exists .e] } {return}
    
    ##deactivate the Equation and Exercise buttons
    #set mx(eqn,on) 0
    #set mx(exc,on) 0
    #updateActive $mx(eqn,chkBut) eqn
    #updateActive $mx(exc,chkBut) exc
    
    ## set the bitmap for the faraday equation and also set the position
    set bitmapf [pwd]
    set bitmapf $bitmapf/equation.gif
    set bmx -.15c
    set bmy -.08c
   image create photo bm -format gif -file $bitmapf
    
    ## set the top level window and associated frames
    set Equt [toplevel .e -class Dialog]
    wm title .e "Equation"
    frame $Equt.top -bg lightblue -highlightthickness 0
    frame $Equt.mid -bg lightblue -highlightthickness 0
    frame $Equt.low -relief raised -width 5c -height 1.3c -bd 1m -background lightblue -highlightthickness 0
    pack $Equt.top $Equt.mid $Equt.low -in $Equt -side top -padx 0m -pady 0 -expand 1 -fill both
    
    ## canvas for setting the faraday's equation 
    canvas $Equt.canvas -width 10.5c -height 14.5c
    $Equt.canvas configure -background lightblue
    $Equt.canvas create image $bmx $bmy -image bm -anchor nw
    pack $Equt.canvas -in $Equt.top -fill both -padx 0m -pady 1m

    ## scrollable text for explaining faraday's law,  and associated buttons
    text $Equt.mid.text -relief raised -bd 2 -yscrollcommand "$Equt.mid.scroll set"  -width 65 -height 10 -wrap word
    scrollbar $Equt.mid.scroll -command "$Equt.mid.text yview"
    button $Equt.audio  -text Audio -command {QuitEqut} -state disabled
    button $Equt.low.button -text Done -highlightbackground lightblue -command {Quiteqn}
    button $Equt.low.audio -text Audio -highlightbackground lightblue -command {Quiteqn}  -state disabled
    pack $Equt.low.button -side right 		
    pack $Equt.low.audio -side left
    pack $Equt.mid.scroll -side right -fill y
    pack $Equt.mid.text -side left -fill both
    
    ## read in the text explaining the equation from the file eqn.txt
    $Equt.mid.text delete 1.0 end
    set f [open $file]
    while {![eof $f]} {
	$Equt.mid.text insert end [read $f 1000]
    }
    close $f

}

#Testing - procedure for taking the test with the questions
proc Testing { } {
  proc QuitQ { } {
    global mx theList .e
      set mx(exc,on) 1
      .e.next configure -state normal
      set mx(exc) 1
      destroy .e
     }

proc QuitD { } {
     global mx f
          .e.next configure -state normal -text Next -command {NextQuestion}
	  .e.prev configure -state disabled
	  set mx(exc) 1
          destroy $f
          {AskQuestion}
      }

proc ReStart { } {
     {QuitQ}
     {Parameterexc}
}

### procedure to draw the exercise window 

proc Parameterexc { } {
    global mx .e answer ans 
    if { [winfo exists .e] } { return } 
    for {set i 0} {$i <= 18} {incr i } {
	set ans($i) u
    }
    set zero 0
    set one 1
    set answer u
    
    set mx(exc,on) 0
    
    ## set the top level window and redraw screen canvas
    toplevel .e
    wm title .e "Experimental Questions"
    update idletasks

    set mx(exc) 1
    set mx(qt) t_text 
    
    ## creates several generic frames for packing
    for {set i 0} {$i < 5} {incr i +1} {
	frame .e.top$i
    }
    .e.top1 configure -relief raised -border .25m
    .e.top3 configure -relief raised -border .25m
    .e.top4 configure -relief raised -border .25m
    pack .e.top0 .e.top1 .e.top2 .e.top3 .e.top4\
	    -in .e -side top -padx 0m -pady 0m\
	    -expand 1 -fill both
    
    ## creates check buttons and radiobuttons for recording answers 
    label .e.experiment -text "Exercise"
    label .e.number -text "Question:"
    canvas .e.can -width 15c -height 2c
    .e.can configure -background white
    radiobutton .e.yes -variable answer -text Yes -value $one
    radiobutton .e.no -variable answer -text No -value $zero
#    button .e.done -width 5 -height 1 -relief raised -text Done -state normal -command {Dialog}
    button .e.next -width 5 -height 1 -relief raised\
	    -text Next -command {NextQuestion} 
    button .e.prev -width 7 -height 1 -relief raised\
            -text Previous -command {PrevQuestion}
    button .e.restart -width 7 -height 1 -relief raised\
	-text Restart -command {ReStart}
    button .e.cancel -width 7 -height 1 -relief raised\
	-text Cancel -command {QuitQ}
    pack  .e.number -in .e.top1 -side left  -padx 1m -pady 1m -expand 0 \
	    -fill x -anchor w
    pack .e.can -in .e.top2 -fill both
    pack .e.yes .e.no -in .e.top3 -side left -padx 10
#    pack .e.done -in .e.top1 -side right -padx 10 -pady 5 -expand 0 \
	    -fill x -anchor w
    pack .e.restart -in .e.top4 -side right -padx 11 -pady 5
    pack .e.cancel -in .e.top4 -side right -padx 10 -pady 5 
    pack .e.prev -in .e.top4 -side left -padx 10 -pady 5
    pack .e.next -in .e.top4 -side left -padx 11 -pady 5
    .e.can create text 10 2 -text "Will emf be generated" -fill blue -anchor nw -tag $mx(qt)
    
    ## call the procedure to generate the first question
    {AskQuestion}
}

### the procedure that puts up the dialog box after the questions are answered

proc Dialog { } {
    global ans answer f
    set ans(10) $answer
    set correct 0
    set untouched u

    ## set the correct answer list and compare the answers against this list
    set correctList {u 0 0 0 1 1 1 0 0 1 1}
    set j 1
    for {set i 1} {$i <= 10} {incr i 1} {
	set x [lindex $correctList $i]
	if { $x == $ans($i) } {
	    incr correct
##	    puts $correct
	} else {
	   if { $ans($i) != $untouched } {
            set wrong($j) $i
            set j [expr $j + 1]
	   }
	}  
    }

    set per [expr $correct*100/10]; # calculate the percent correct answers
##    puts $per
    
    ## output the appropriate messages to the user
    set f [toplevel .results -borderwidth 10 -bg white -width 40]
    if {$per != 100} {
	message $f.msg0 -aspect 1000 -justify left -bg white -anchor w -text \
	"You have answered $correct correct out of 10 total questions."  
	message $f.msg0a -aspect 1000 -justify left -bg white -text \
	"Your score:  $per %."
	message $f.msg0b -aspect 1000 -justify left -bg white -anchor w -text \
        "You have answered the following questions incorrectly:"
	pack $f.msg0 -side top -fill x
	pack $f.msg0a -side top -fill x
	pack $f.msg0b -side top -fill x
        set why(1) "The B.L diagram is based on the tangents to the field and loop."
	set why(2) "The sum of the flux decreases as the loop is farther from the point charge."
	set why(3) "The flux is the same for the same distance from the point source, regardless of its position with respect to the point charge."
	set why(4) "A larger magnetic field intensity relates to larger flux values."
	set why(5) "Ampere's Law is one of Maxwell's equations."
	set why(6) "Varying wire shapes will cause different flux values."
	set why(7) "The sum of total flux around a wire loop is always zero."
	for {set k 8} {$k < 11} {incr k 1} {
	    set why($k) "Explanation..."
        } 
	for {set i 1} {$i < $j} {incr i 1} {
	    message $f.msg{$i} -aspect 1000 -justify left -anchor w -bg white -fg blue \
		-text "Question $wrong($i): $why($i)"
	    pack $f.msg{$i} -fill x
        }
	message $f.msg{[expr $j + 1]} -aspect 1000 -justify left -bg white \
	    -text "Please try again."
	pack $f.msg{[expr $j + 1]} -side top -fill x 
    } else {
	message $f.msg -aspect 1000 -justify left -bg white -text "Congratulations! You got all the answers."
        pack $f.msg -side top -fill x
    }
    button $f.button -text OK -command {QuitD}
    pack $f.button -side top  -padx 10 -pady 10
    
    ## grab focus fr this window until it is exited
    focus $f.button
    grab $f
    tkwait window .e
    grab release $f
#    destroy $f
}

### procedure called when the user hits the "Previous" button
### control is passed back to the previous question in the list

proc PrevQuestion { } {
    global mx ans answer
    set index $mx(exc)
    set ans($index) u
    set mx(exc) [expr $mx(exc) - 1]
    {AskQuestion}
}

### procedure called when a question is answered and "Next" is pressed
### the index is calculated and the 'answer' recorded in list 'ans'

proc NextQuestion { } {
    global mx ans answer
    set index $mx(exc)
    set ans($index) $answer
    set answer u
    set mx(exc) [expr $mx(exc) + 1]
    {AskQuestion}
}
    
### call the appropriate question depending on the exercise number.

proc AskQuestion { } {
    global mx
    switch -exact $mx(exc) {
	1 {q1}
	2 {q2}
	3 {q3}
	4 {q4}
	5 {q5}
	6 {q6}
	7 {q7}
	8 {q8}
	9 {q9}
	10 {q10}
    }
}

#####################################################################
# the procedures to implement the questions above are presented below
# the generic procedure used in the implementation are defined in 'excProc'
# the procedures contain the questions to be put on the canvas accompnaying 
# the animations
#####################################################################

### question #1:

proc q1 { } {
    global mx .e .e.can mid main ans answer ques1 
    .e.prev configure -state disabled
    .e.restart configure -state normal
    .e.can delete $mx(qt)  
    set ques1 "The B.L integration step diagram is based on the normals"
    set ques1b " to the magnetic field and the wire loop."
    .e.can create text 260 35 -text $ques1 -fill blue -anchor center -tag $mx(qt)
    .e.can create text 260 50 -text $ques1b -fill blue -anchor center -tag $mx(qt)
}

### question 2:

proc q2 { } {
    global mx .e .e.can 
    .e.prev configure -state normal
    .e.can delete $mx(qt)
    set ques2 "The sum of the flux increases as the wire loop is farther"
    set ques2b " from the point charge."
    .e.can create text 260 35 -text $ques2 -fill blue -anchor center -tag $mx(qt)
    .e.can create text 260 50 -text $ques2b -fill blue -anchor center -tag $mx(qt)}


### question 3: 
proc q3 { } {
    global mx
    .e.can delete $mx(qt)
    set ques3 "The total flux is twice as strong when the wire loop is above"
    set ques3b "the point charge as when it is below."
    .e.can create text 260 35 -text $ques3 -fill blue -anchor center -tag $mx(qt)
    .e.can create text 260 50 -text $ques3b -fill blue -anchor center -tag $mx(qt)
}

### question 4: 

proc q4 { } {
    global mx
    .e.can delete $mx(qt)
    set ques4 "As the magnetic field intensity increases, the range of flux value"
    set ques4b " increases."
    .e.can create text 260 35 -text $ques4 -fill blue -anchor center -tag $mx(qt)
    .e.can create text 260 50 -text $ques4b -fill blue -anchor center -tag $mx(qt)
}

### question 5: 
proc q5 { } {
    global mx
    .e.can delete $mx(qt)
    set ques5 "Ampere's Law is part of Maxwell's equations."
    .e.can create text 260 35 -text $ques5 -fill blue -anchor center -tag $mx(qt)
}

### question 6: 
proc q6 { } {
    global mx
    .e.can delete $mx(qt)
    set ques6 "The change in loop shape directly affects resultant flux values."
    .e.can create text 260 35 -text $ques6 -fill blue -anchor center -tag $mx(qt)
}

### question 7: 
proc q7 { } {
    global mx
    .e.can delete $mx(qt)
    set ques7 "The sum of the flux around the wire loop varies with the distance"
    set ques7b "from the point source."
    .e.can create text 260 35 -text $ques7 -fill blue -anchor center -tag $mx(qt)
    .e.can create text 260 50 -text $ques7b -fill blue -anchor center -tag $mx(qt)
}

### question 8: 
proc q8 { } {
    global mx x mid mid.main
    .e.can delete $mx(qt)
    set ques8 "Question 8"
    .e.can create text 50 35 -text $ques8 -fill blue -anchor center -tag $mx(qt)
}

### question 9:
proc q9 { } {
    global mx x
    .e.next configure -state normal -text Next -command {NextQuestion}
    .e.can delete $mx(qt)
    set ques9 "Question 9"
    .e.can create text 50 35 -text $ques9 -fill blue -anchor center -tag $mx(qt) 
}

### question 10: 
proc q10 { } {
    global mx .e.done .e ans answer 
    .e.can delete $mx(qt)
    set ques10 "Question 10"
    .e.can create text 50 35 -text $ques10 -fill blue -anchor center -tag $mx(qt)
    set ans(10) $answer
    update idletasks    
    .e.next configure -text Done -state normal -command {Dialog}
    ## update states of the "Done" and "Next" buttons
#    .e.done configure -state normal 
#    .e.next configure -state disabled
}
  

Parameterexc

}


# Start - procedure for  starting the integration, configuring and disabling the rest
# of the options, leaving only the  stop integration button

proc Start { } {
    global envir center_x center_y loop_x loop_y lista x_box y_box loop_rad steps mag_x mag_x_step
   proc Back { } {
       set m .menu.menu
       set c .menu.choice
       set e .menu.main.bar.ent.val
      .menu.main.glaven.can delete segms 
     # update 
	if {[winfo exists .integ]} {
      
        .menu.main config -cursor top_left_arrow
	.menu.choice.exper config -text "Start Integration" -command Start -state disabled
       .menu.messag.mesg config -text "You need to close the Integrator Box to continue with your work"
       
        
	set l [list $m.main $m.app $m.av $m.help $c.getstart $c.show $c.finish $e $c.summary]
       foreach b $l {
           $b config -state normal
          }
       .menu.choice.exper config -state normal
    } else { Integrator
             .menu.main config -cursor top_left_arrow
	.menu.choice.exper config -text "Start Integration" -command Start -state disabled
       .menu.messag.mesg config -text "You need to close the Integrator Box to continue with your work"
      
        
	set l [list $m.main $m.app $m.av $m.help $c.getstart $c.show $c.finish $e $c.summary]
       foreach b $l {
           $b config -state normal
          }
       .menu.choice.exper config -state normal
    }

 }

      


  
   proc dot_product {x1 y1 x2 y2 } {
       return [expr $x1*$x2+$y1*$y2]
   }

  proc draw_tangents { } {
    global steps pi loop_rad x_box y_box loop_diam center_x center_y loop_scale envir field_scale lista loop_x loop_y lx mag_x

    set start_angle 0
    set end_angle 360
    set del_angle [expr ($end_angle-$start_angle)/$steps]
    set envir_intense $envir(intense)

    #perform integration steps
    
    for {set i 0} {$i < 360} {set i [expr $i+$del_angle]} {
   
        # calculate angle in radians
        set l_angle [expr ($i*$pi)/180.0]
        set x [expr $loop_x+cos($l_angle)*$loop_rad]
        set y [expr $loop_y+sin($l_angle)*$loop_rad]
	# determine the direction of tangent line l
	set tang_x [expr $loop_x+cos($l_angle+$pi/2.0)*$loop_rad]
        set tang_y [expr $loop_y+sin($l_angle+$pi/2.0)*$loop_rad]

	#find radius to points on loop
	#scale tangent
	set l_hypot [expr hypot($loop_x-$tang_x,$loop_y-$tang_y)]
	set scaled_x [expr ($loop_x-$tang_x)/$l_hypot*100]
	set scaled_y [expr ($loop_y-$tang_y)/$l_hypot*100]

	#find normals to circle loop

	#find tangents to circle loop
	if { [expr ($i%(4*$del_angle)) == 0] } {
	    .menu.main.glaven.can create line $x $y [expr $x+$scaled_x] [expr $y+$scaled_y] -fill green -tags tangenti
           }
        update
	#Mag field information

	#calculate point on loop radius to point charge
	set fx_dist [expr $x-$center_x ]
	set fy_dist [expr $y-$center_y ]

	set field_rad [expr hypot($fx_dist,$fy_dist)]

	#determine the direction of tangents of mag field
	set f_angle [expr atan($fy_dist/$fx_dist)]

	if { $x > $center_x } {
         set tang_fx [expr $center_x+cos($f_angle+$pi/2.0)*$field_rad]
	 set tang_fy [expr $center_y+sin($f_angle+$pi/2.0)*$field_rad]
	} else {
	    set tang_fx [expr $center_x+cos($f_angle-$pi/2.0)*$field_rad]
	    set tang_fy [expr $center_y+sin($f_angle-$pi/2.0)*$field_rad]
          }

	#scale tangents of mag field
	set f_hypot [expr hypot($center_x-$tang_fx,$center_y-$tang_fy)]
	set scaled_fx [expr ($center_x-$tang_fx)/$f_hypot*($envir_intense/$f_hypot*5000)]
	set scaled_fy [expr ($center_y-$tang_fy)/$f_hypot*($envir_intense/$f_hypot*5000)]
        
	#draw tangents of mag field
	if { [expr ($i%(4*$del_angle)) == 0] } {
       .menu.main.glaven.can create line $x $y [expr $x+$scaled_fx] [expr $y+$scaled_fy] -fill red -tags tangenti
        set record [list $x $y $scaled_x $scaled_y $scaled_fx $scaled_fy]
	lappend lista $record
        .menu.main.bar.canvas2 delete tangent
        .menu.main.bar.canvas2 create line 90 60 [expr 90+$scaled_fx/3] [expr 60+$scaled_fy/3] -fill red -tags tangent
       .menu.main.bar.canvas2 create line 90 60 [expr 90+$scaled_x/3] [expr 60+$scaled_y/3] -fill green -tags tangent
   
        update
        
	set lx  [llength $lista]
        set x1 $lx
	}
	set d_p  [dot_product $scaled_fx $scaled_fy $scaled_x $scaled_y] 

	#if positive, put into yellow field
	set curr_color [expr int($d_p/60000*256)]

	if { $curr_color > 0 } {
	    set hex_no [format "%4s%02x" ffff [expr 255-$curr_color*8]]
	} else {
	    #if negative, put into blue
	    set curr_color [expr abs($curr_color)]
	    if { $curr_color > 51 } {
		set curr_color 51
	    }
	    set hex_no [format "%02x%4s" [expr 255-$curr_color*5] ffff]
	}

	#change color of loop to represent intensity
	.menu.main.glaven.can create line $x $y [expr $x+$scaled_x/10] [expr $y+$scaled_y/10] -fill \#$hex_no -width 5 -tags segms

	# routines to calculate 2 smaller canvases


	#set x_arr($i) $x
	#set y_arr($i) $y
	#set sfx_arr($i) $scaled_fx
	#set sfy_arr($i) $scaled_fy
	#set sx_arr($i) $scaled_x
	#set sy_arr($i) $scaled_y

	set d_p_arr($i) $d_p
	set color_arr($i) $curr_color
       # set curr_color  [dot_product $scaled_fx $scaled_fy $scaled_x $scaled_y $x $y] 
     
    #dot product information
    #BL $scaled_fx $scaled_fy $scaled_x $scaled_y
    mag $d_p
    }
}

proc mag { our_color  } {
    global mag_x mag_x_step last_pt
   
    set our_color [expr $our_color/500.0+60.0]

    if { $mag_x > $mag_x_step } {

	if { $our_color > 60 } {
	    .menu.main.bar.canvas3 create line $mag_x 60 $mag_x $our_color -fill yellow 
	    .menu.main.bar.canvas3 create poly [expr $mag_x-$mag_x_step] $last_pt $mag_x $our_color $mag_x 60 [expr $mag_x-$mag_x_step] 60 -fill yellow -smooth true  
	} else {
	    .menu.main.bar.canvas3 create line $mag_x 60 $mag_x $our_color -fill cyan 
	.menu.main.bar.canvas3 create poly [expr $mag_x-$mag_x_step] $last_pt $mag_x $our_color $mag_x 60 [expr $mag_x-$mag_x_step] 60 -fill cyan -smooth true  
	}

	.menu.main.bar.canvas3 create line [expr $mag_x-$mag_x_step] $last_pt $mag_x $our_color -fill black -smooth true -width 2
# 0 line
    .menu.main.bar.canvas3 create line 0.0 60.0 180.0 60.0 -fill black
    }
    set mag_x [expr $mag_x+$mag_x_step]
#    puts "[expr 300.0 - $f_hypot/2.0]"    
    set last_pt $our_color
    
}

proc Frame { x } {
   global lista    
   .menu.main.glaven.can delete tangenti
   .menu.main.bar.canvas2 delete tangent
  # .menu.main.glaven.can delete segms
    set l1 [lrange $lista 0 [expr $x-1]]
    
    foreach q $l1 {
	set x1 [lindex $q 0]
        set y1 [lindex $q 1]
        set x2 [lindex $q 2]
        set y2 [lindex $q 3]
        set x3 [lindex $q 4]
        set y3 [lindex $q 5]
        
 .menu.main.glaven.can create line $x1 $y1 [expr $x1+$x3] [expr $y1+$y3] -fill red -tags tangenti
 .menu.main.glaven.can   create line $x1 $y1 [expr $x1+$x2] [expr $y1+$y2] -fill green -tags tangenti
.menu.main.glaven.can create line $x1 $y1 [expr $x1+$x2/10] [expr $y1+$y2/10]
  .menu.main.bar.canvas2 delete tangent
 .menu.main.bar.canvas2 create line 90 60 [expr 90+ $x3/3] [expr 60+$y3/3] -fill red -tags tangent
 .menu.main.bar.canvas2 create line 90 60 [expr 90+$x2/3] [expr 60+$y2/3] -fill green -tags tangent
  

  }
}

# Integrator - creates a toplevel frame which controls the progress of the integration
#and the textvariable x is associated with one of the 20 frames of the integration

proc Integrator { } {
 global lista lx
   
 set f [toplevel .integ -height 30]
 scale $f.scale -from 0 -to 20 -length 200 -variable lx \
     -orient horizontal -tickinterval 5 -showvalue true -command Frame
 label $f.label -text Integrator -padx 0 
 label $f.label1 -text FrameNo -padx 0
 entry $f.ent -width 10 -textvariable lx 

 bind $f.ent <Return> {Frame $x}
 pack $f.label $f.scale $f.label1 $f.ent -side left
 tkwait window $f
}

# number of integration steps
set steps 80
set loop_diam [expr $envir(size)*30]

#box for loop size,  may go away
set x_box [expr $loop_x+$loop_diam]
set y_box [expr $loop_y+$loop_diam]
set pi 3.14159
set envir_intense $envir(intense)
set loop_rad [expr $envir(size)*30]

#scales to make integration readable
set loop_scale 100
set field_scale 5000

#scales for integration summary
set mag_x_step 2
set mag_x $mag_x_step

#given from program, max charge and center of mag field
set envir_intense $envir(intense)
set lista []


#########################################################################

    .menu.main.glaven.can delete tangenti
    .menu.main.glaven.can delete segms
    .menu.main.bar.canvas3 delete all 
    .menu.main config -cursor watch
    .menu.messag.mesg config -text " You need to Stop the Integration in order to go on with your further work"
    .menu.choice.exper config -text "Stop Integration" -command Back
    
    draw_tangents 
    Integrator
   
    set m .menu.menu
    set c .menu.choice
    set e .menu.main.bar.ent.val
    set l [list $m.main $m.app $m.av $m.help $c.getstart $c.show $c.finish $e $c.summary]
    foreach b $l {
      $b config -state disabled
    }    
}


#Amperes1 - procedure for showing the Ampere's Law
proc Amperes1 { } {
    set t [ toplevel .ampt1 ]
   label $t.ampl1 -text "Ampere's Law"
   set ff [pwd]
   set ff $ff/35-2.gif
   image create photo ampgif352 -format gif -file $ff 
   label $t.ampimg1 -image ampgif352
   button $t.okbut -text "OK" -command "destroy .ampt1"
   pack $t.ampl1 $t.ampimg1 $t.okbut -side top
}


proc ThisTool {} {
   after idle { .bihelp.msg configure -wraplength 4i}
   set i [tk_dialog .bihelp "How to use this Tool" \
   "This tool allows you to change the following parameters of the Ampere's Law Eqation:

1) The strength of the point charge.
2) The distance of the wire loop from the point charge.
3) The shape of the wire loop.

When you press the 'Start Integration' button to calculate the induced current in the wire loop, the tool takes into account your current settings for the paramters.

You can stop the integration at any time by pressing the 'Stop Integration' button and change one or more of the parameters.  Then press the 'Start Integration' button again to see how your changes have altered the integration calculation." info 0 OK ] 
}

proc EvalHelp {} {
   after idle { .bihelp.msg configure -wraplength 4i}
   set i [tk_dialog .bihelp "Evaluate Help Text" \
   "'Show Integration Results' displays summary information about the experiments you have run during this execution of the tool.

'Take Test' allows you to evaluate your understanding of Ampere's Law." info 0 OK ] 
}

proc ChLoopHelp {} {
   after idle { .bihelp.msg configure -wraplength 4i}
   set i [tk_dialog .bihelp "Change Loop Help Text" \
   "With this screen you can change four things:
1) The shape of the wire loop
2) The shape of the integrator
3) The distance of the center of the wire loop from the point charge.
4) The size of the wire loop

Press the left mouse button to choose a wire shape or to choose the \
shape of the integrator.

You can enter a numeric value for the distance of the center of the wire loop from the point source.

You can enter a numeric value for the radius of a circular wire loop or for the length of a side of a triangle or square wire loop.

Press OK to have your changes take effect.
Press Cancel to undo your changes.
Press Defaults to reset the four values to their original states." info 0 OK ] 
}

proc invoke index {
    global tk_library 
    set t .main1.tex
    set tags [$t tag names $index]
    set i [lsearch -glob $tags demo-*]
    if {$i < 0} {
	return
    }
    $t configure -cursor watch
    $t configure -state disabled
    update
   set demo [string range [lindex $tags $i] 5 end]
   # uplevel [list source $tk_library/demos/$demo.tcl]
    $demo
    update
    $t configure -cursor xterm 
}

proc Overview { } {
set font -*-Helvetica-Medium-R-Normal--*-140-*-*-*-*-*-*

set t .main1.tex
set b .main1.b

text $t -wrap word -width 40\
     -font $font -setgrid 1
button $b -text OK -command {destroy .main1}
pack $t -expand y -fill both
pack $b -side bottom

$t tag configure title -font -*-Helvetica-Bold-R-Normal--*-180-*-*-*-*-*-*
$t tag configure demo -lmargin1 1c -lmargin2 1c -foreground blue -underline 1
if {[winfo depth .] == 1} {
     $t tag configure hot -background black -foreground white
   } else {
    $t tag configure hot -relief raised -borderwidth 1 -foreground blue -underline 1
     }
$t tag bind demo <Button-1> {
    
    invoke [$t index current]
   
   } 
set lastLine ""
$t tag bind demo <Enter> {
    set t .main1.tex
    set lastLine [$t index {@%x,%y linestart}]
    $t tag add hot $lastLine "$lastLine lineend"
    $t config -cursor hand2
    $t tag configure hot -foreground red
   }
$t tag bind demo <Leave> {
    set t .main1.tex
    $t tag remove hot 1.0 end
    $t config -cursor xterm
    $t tag configure hot -foreground blue
    
}
$t tag bind demo <Motion> {
    set t .main1.tex
    set newLine [$t index {@%x,%y linestart}]
    if {[string compare $newLine $lastLine] != 0} {
    $t tag remove hot 1.0 end
    set lastLine $newLine
  $t tag add hot $lastLine "$lastLine lineend"
   }
}

$t insert end \n {} 
$t insert end "\t   Contents\n" title 
$t insert end \n {} 


$t insert end "1. What is Ampere's Law ? \n" { demo demo-Amperes1}
$t insert end "       An introduction to Ampere's\n       Law and how this tool uses it.\n"
$t insert end \n {} 
$t insert end "2. Ampere's Equation\n" {demo demo-Amperes}
$t insert end "       The formulas needed to\n       understand Ampere's Law.\n"

$t insert end \n {} 
$t insert end "3. How to use this tool\n" {demo demo-ThisTool}
$t insert end "       An overview to get the most\n       from this program.\n"

$t insert end \n {} 
$t insert end "4. Show Summary\n" {demo demo-Summary}
$t insert end "       The restults of performing\n       every possible test.\n"

$t insert end \n {} 
$t insert end "5. Take Test\n" {demo demo-Testing}
$t insert end "       Test your knowledge with an\n       interactive test.\n"


$t  configure -state disabled
} 

proc Summary { } {
  set m1 "Summary"
  set m2 "Now a screen with summary of all the test that have been done so far with conclusions would show up"
  Dialog $m1 $m2
}

proc PrintScreen { } {
  set m1 "Print"
  set m2 "Now a screen asking you about how many copies and on which printer do you want to print the current content of the screen"
  Dialog $m1 $m2
}

proc About { } {
   set m1 "About this Tool"
   set m2 "This tool was created by K.Bruso, D.Doyle, B.Dahlen and M.Petrov, graduate students at the Univerisity of Minnesota Computers Science Department"
   Dialog $m1 $m2
}

# main frames of the screen
set mmenu .menu.menu  
set main .menu.main 
set choice .menu.choice
set msg .menu.messag

#variables inside the envir(onment) array
#set choice2 0
#set choice1 0
set envir(dist) 4 ;            			#distance from the point charge in cm
set envir(size) 2 ;			        #the radius/side of the wire shape
set envir(looptype) "circle"; 			# the current type of loop
set envir(num) first ; 		# the default button for wire shape in change loop menu
set envir(num1) first ; 	# the default button for force diagram in change loop menu
set envir(force) "three" ; 			#the current type of force diagram
set envir(intense) 3.5 ; 			# the default value of the field strength
set envir(module) 4 ; 				# the module of the field strength
set envir(forim) [pwd] ; 			# current directory
set value $envir(intense) ; 			# auxiliary variable for the field strength
set steps 20
set pi 3.1417
set lista []
frame .menu 

frame $mmenu -height 20
frame $main -height 360  -bg black
frame $choice -height 80
frame $msg -height 20 -bg white
frame .menu.help -height 20 -bg white
frame .main1 -height 360 -width 50

pack $mmenu $main  $choice $msg .menu.help -side top -fill x
pack .menu .main1 -side left

# setting the choices of the menu bar
Overview
set m1 $mmenu.main.m1
set m2 $mmenu.app.m2
set m3 $mmenu.av.m3
set m4 $mmenu.help.m4

menubutton $mmenu.main -text "Main" -underline 0 -menu $m1
menubutton $mmenu.app -text "Parameters" -underline 0 -menu $m2
menubutton $mmenu.av -text "Audio-Video" -underline 0 -menu $m3 
menubutton $mmenu.help -text "Help" -underline 0 -menu $m4

menu $m1 
menu $m2
menu $m3
menu $m4

$m1 add command -label "Ampere's Law" -command Amperes1
$m1 add command -label "Show Equation" -command Amperes
$m1 add command -label "Start Integration" -command Start
$m1 add command -label "Show Summary" -command Summary
$m1 add command -label "Take Test" -command Testing 
$m1 add separator
$m1 add command -label "Print Screen" -command PrintScreen
$m1 add command -label "Exit" -command { destroy . }

$m2 add command -label "Change Loop ..." -command ChangeLoop
$m2 add command -label "Change Point Charge ..." -command ChangeIntensity 

$m3 add command -label "Audio" -command Audio -state disabled
$m3 add command -label "Visual" -command Visual -state disabled

$m4 add command -label "Ampere's Law" -command Amperes1
$m4 add command -label "How to use this Tool" -command ThisTool
$m4 add command -label "About this Tool" -command About


pack $mmenu.main $mmenu.app $mmenu.av $mmenu.help -side left


#setting the right side of the main screen with the slider bar and the force diagram
frame $main.bar -width 150 -height 360 -bg white		
canvas $main.bar.canvas1 -width 180 -height 50
set w $main.bar.canvas1
frame $main.bar.ent -width 180 -height 10
frame $main.glaven -width 490 -height 360
Scale2  $w 0 100
label $main.bar.ent.l -text "Field Strength (0-10Wb)" -padx 0
entry $main.bar.ent.val -width 4 -relief sunken -textvariable value
bind $main.bar.ent.val <Return> {SetValue $w lbox}
bind $main.bar.ent.val <Control-c> Stop

canvas $main.glaven.can -height 320 -width 490 -bg black
canvas $main.bar.canvas2 -bg grey -height 120 -width 180
# $main.bar.canvas2 create text 50 100 -text "Module"    
#set forceim [$main.bar.canvas2 create bitmap 50 50 -bitmap @$envir(forim)/three.xbm -anchor w -tags forcing]
canvas $main.bar.canvas3 -bg grey -height 120 -width 180 


pack $main.bar.ent.l -side left
pack $main.bar.ent.val -side left -fill x 
pack $main.bar.canvas2 $main.bar.canvas3 $main.bar.ent $main.bar.canvas1 -side top -expand true -fill x

pack $main.glaven.can
pack $main.glaven $main.bar -side left

Animate $main.glaven.can

# setting the button menu at the bottom of the screen

frame $choice.labels
label $choice.labels.lab1 -text Results
label $choice.labels.lab2 -text Background
button $choice.getstart -text "What is Ampere's Law?"  -command Amperes1 -wraplength 60
button $choice.show -text "Ampere's Equation" -command Amperes -wraplength 60 -pady 10
button $choice.exper -text "Start Integration" -command Start -wraplength 65 -pady 10
button $choice.finish -text "Take Test" -command Testing -wraplength 120 -pady 18
button $choice.summary -text "Show Summary" -command Summary -wraplength 65 -pady 10
pack $choice.labels.lab2 -side left -padx 60
pack $choice.labels.lab1 -side right -padx 75
pack $choice.labels -side top -fill x
pack $choice.getstart $choice.show -padx 5 -side left
pack $choice.exper -padx 70 -side left
pack $choice.finish  $choice.summary -padx 5 -side right 
     
#setting the help and message bar at the bottom of the screen
 
message $msg.mesg  -borderwidth 2 -bg white  -text "Introduction to Learning Ampere's Law" -width 600
pack $msg.mesg -side left
message .menu.help.mesg -text "University of Minnesota" -width 600 -bg white -borderwidth 2
pack .menu.help.mesg -side left


